// DrawArrowDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include <math.h>
#include "DrawArrow.h"
#include "DrawArrowDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDrawArrowDlg _CAO

CDrawArrowDlg::CDrawArrowDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDrawArrowDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDrawArrowDlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDrawArrowDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDrawArrowDlg)
		// : ̏ꏊɂ ClassWizard ɂ DDX  DDV ̌Ăяoǉ܂B
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDrawArrowDlg, CDialog)
	//{{AFX_MSG_MAP(CDrawArrowDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDrawArrowDlg bZ[W nh

BOOL CDrawArrowDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	m_isDrawing = false;	

	return TRUE;
}

void CDrawArrowDlg::OnPaint() 
{
	CDialog::OnPaint();

	if(m_isDrawing)
	{
		CClientDC dc(this);
		dc.MoveTo(m_startPos);
		dc.LineTo(m_curPos);

		int x, y;
		x = m_curPos.x - m_startPos.x;
		y = m_curPos.y - m_startPos.y;
		double r = atan2(y, x);

		POINT arrowHead[2], newArrowHead[2];	// index 0 is L, and another is R.
		arrowHead[0].x = -20;
		arrowHead[0].y = -20;
		arrowHead[1].x = -20;
		arrowHead[1].y =  20;
		for(int j = 0; j < 2; j++)
		{
			newArrowHead[j].x = (int)(arrowHead[j].x * cos(r) - arrowHead[j].y * sin(r));
			newArrowHead[j].y = (int)(arrowHead[j].x * sin(r) + arrowHead[j].y * cos(r));
		}

		dc.MoveTo(m_curPos);
		dc.LineTo(m_curPos + newArrowHead[0]);
		dc.MoveTo(m_curPos);
		dc.LineTo(m_curPos + newArrowHead[1]);
	}
}

HCURSOR CDrawArrowDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDrawArrowDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if(m_isDrawing)
	{
		m_curPos = point;
		m_isDrawing = false;
	}

	CDialog::OnLButtonUp(nFlags, point);
}

void CDrawArrowDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_isDrawing = true;
	m_startPos = m_curPos = point;
	Invalidate();

	CDialog::OnLButtonDown(nFlags, point);
}

void CDrawArrowDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(m_isDrawing)
	{
		RECT rc;
		rc.left   = min(m_startPos.x, min(m_curPos.x, point.x));
		rc.top    = min(m_startPos.y, min(m_curPos.y, point.y));
		rc.right  = max(m_startPos.x, max(m_curPos.x, point.x));
		rc.bottom = max(m_startPos.y, max(m_curPos.y, point.y));
		InflateRect(&rc, 30, 30);

		InvalidateRect(&rc);
		m_curPos = point;
	}

	CDialog::OnMouseMove(nFlags, point);
}
